## shasta 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(shasta)

# This is the top level cmake file for a Shasta build. 
# Use "cmake -D" to modify these option defined below 
# in each "option" line. For example, to turn off
# building the dynamic executable use
# cmake -DBUILD_DYNAMIC_EXECUTABLE=OFF

set(X86_64 OFF)
if(${CMAKE_HOST_SYSTEM_PROCESSOR} MATCHES "x86_64")
    set(X86_64 ON)
endif()

# Figure out if we are on macOS.
set(MACOS OFF)
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(MACOS ON)
endif()

message(STATUS "Processor architecture is " ${CMAKE_HOST_SYSTEM_PROCESSOR})
message(STATUS "CMAKE_SYSTEM_NAME is " ${CMAKE_SYSTEM_NAME})
message(STATUS "MACOS is " ${MACOS})


# Decide what we want to build.
if(MACOS)
    # For MacOS, only do the static builds.
    option(BUILD_STATIC_LIBRARY "Build the static library." ON)
    option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
    option(BUILD_DYNAMIC_LIBRARY "Build the shared library." OFF)
    option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)
    option(BUILD_APPIMAGE "Build the AppImage." OFF)
else(MACOS)
    # SPOA's cpu dispatching code does not compile on Ubuntu versions lesser than 18.04
    execute_process(COMMAND cat /etc/os-release
        COMMAND grep VERSION_ID
        COMMAND cut -f 2 -d=
        COMMAND tr -d \"
        OUTPUT_VARIABLE UBUNTU_VERSION)
    if(UBUNTU_VERSION VERSION_LESS "18.04")
        option(BUILD_USE_SPOA_WITH_CPU_DISPATCH "Link to SPOA library which uses cpu dispatch" OFF)    
    else(UBUNTU_VERSION VERSION_LESS "18.04")
        option(BUILD_USE_SPOA_WITH_CPU_DISPATCH "Link to SPOA library which uses cpu dispatch" ON)
    endif(UBUNTU_VERSION VERSION_LESS "18.04")
    message(STATUS "BUILD_USE_SPOA_WITH_CPU_DISPATCH is " ${BUILD_USE_SPOA_WITH_CPU_DISPATCH})
   
    # For Linux, build everything.
    option(BUILD_STATIC_LIBRARY "Build the static library." ON)
    option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
    option(BUILD_DYNAMIC_LIBRARY "Build the shared library." ON)
    option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." ON)
    option(BUILD_APPIMAGE "Build the AppImage." OFF)
endif(MACOS)



# To build the static executable, we also need the static library.
if(BUILD_STATIC_EXECUTABLE AND NOT BUILD_STATIC_LIBRARY)
    set(BUILD_STATIC_LIBRARY ON)
    message(STATUS "Turned on BUILD_STATIC_LIBRARY because it is needed for BUILD_STATIC_EXECUTABLE.")
endif(BUILD_STATIC_EXECUTABLE AND NOT BUILD_STATIC_LIBRARY)



# To build the AppImage, we also need the dynamic executable.
if(BUILD_APPIMAGE AND NOT BUILD_DYNAMIC_EXECUTABLE)
    set(BUILD_DYNAMIC_EXECUTABLE ON)
    message(STATUS "Turned on BUILD_DYNAMIC_EXECUTABLE because it is needed for BUILD_APPIMAGE.")
endif(BUILD_APPIMAGE AND NOT BUILD_DYNAMIC_EXECUTABLE)



# To build the dynamic executable, we also need the dynamic library.
if(BUILD_DYNAMIC_EXECUTABLE AND NOT BUILD_DYNAMIC_LIBRARY)
    set(BUILD_DYNAMIC_LIBRARY ON)
    message(STATUS "Turned on BUILD_DYNAMIC_LIBRARY because it is needed for BUILD_DYNAMIC_EXECUTABLE.")
endif(BUILD_DYNAMIC_EXECUTABLE AND NOT BUILD_DYNAMIC_LIBRARY)



# Write out what we will actually build.
message(STATUS "BUILD_STATIC_LIBRARY is " ${BUILD_STATIC_LIBRARY})
message(STATUS "BUILD_STATIC_EXECUTABLE is " ${BUILD_STATIC_EXECUTABLE})
message(STATUS "BUILD_DYNAMIC_LIBRARY is " ${BUILD_DYNAMIC_LIBRARY})
message(STATUS "BUILD_DYNAMIC_EXECUTABLE is " ${BUILD_DYNAMIC_EXECUTABLE})
message(STATUS "BUILD_APPIMAGE is " ${BUILD_APPIMAGE})



# Option to build with -march=native.
option(BUILD_NATIVE "Build with -march=native." OFF)
message(STATUS "BUILD_NATIVE is " ${BUILD_NATIVE})



# Option to request a debug build.
option(BUILD_DEBUG "Make a debuggable build." OFF)
message(STATUS "BUILD_DEBUG is " ${BUILD_DEBUG})



# The BUILD_ID can be specified to identify the build
# This is normally used only when building a new GitHub release,
# in which case we use the following option when running Cmake:
# -DBUILD_ID="Shasta Release X.Y.Z"
# BUILD_ID should not contain a comma, otherwise the C preprocessor does not handle it correctly.
if(NOT DEFINED BUILD_ID)
    set(BUILD_ID "Shasta development build. This is not a released version.")
endif(NOT DEFINED BUILD_ID)
message(STATUS "BUILD_ID is: " ${BUILD_ID})



# Add the subdirectories we need.
if(BUILD_STATIC_LIBRARY)
    add_subdirectory(staticLibrary)
endif(BUILD_STATIC_LIBRARY)
if(BUILD_STATIC_EXECUTABLE)
    add_subdirectory(staticExecutable)
endif(BUILD_STATIC_EXECUTABLE)
if(BUILD_DYNAMIC_LIBRARY)
    add_subdirectory(dynamicLibrary)
endif(BUILD_DYNAMIC_LIBRARY)
if(BUILD_DYNAMIC_EXECUTABLE)
    add_subdirectory(dynamicExecutable)
endif(BUILD_DYNAMIC_EXECUTABLE)



# Install to the shasta-install directory.
set(CMAKE_INSTALL_PREFIX .)

# Install the scripts.
file(GLOB SCRIPTS scripts/*.py scripts/*.sh)
install(PROGRAMS ${SCRIPTS} DESTINATION shasta-install/bin)

# Install the configuration files.
install(DIRECTORY conf DESTINATION shasta-install USE_SOURCE_PERMISSIONS)

# Install the docs directory.
install(DIRECTORY docs DESTINATION shasta-install)

# Install the docker directory.
install(DIRECTORY docker DESTINATION shasta-install)

# The targets built in each subdirectory are
# installed by the cmake file of each subdirectory.

=== docker/Makefile ===
# Definitions
git_commit = $(shell git log --pretty=oneline -n 1 | cut -f1 -d " ")
image_name = kishwars/shasta
shasta_version = 0.3.0
tag = ${shasta_version}--${git_commit}

# Steps
build:
	# do the docker build
	docker build -t ${image_name}:${tag} --build-arg git_commit=${git_commit} .
	docker tag ${image_name}:${tag} ${image_name}:latest

push: build
	# Requires ~/.dockercfg
	docker push ${image_name}:${tag}
	docker push ${image_name}:latest

=== dynamicExecutable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(shastaDynamicExecutable)

# C++ dialect.
add_definitions(-std=c++14)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
    add_definitions(-fsanitize=address)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif()

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# Definitions that control what components get built.
add_definitions(-DSHASTA_HTTP_SERVER)
add_definitions(-DSHASTA_PYTHON_API)

# Source files
file(GLOB SOURCES ../srcMain/*.cpp)

# Include directory.
include_directories(../src)

# Define our executable.
add_executable(shastaDynamicExecutable ${SOURCES})
set_target_properties(shastaDynamicExecutable PROPERTIES OUTPUT_NAME "shastaDynamic")

# This is needed to make sure the executable looks for the shared
# library in the same directory.
set_target_properties(shastaDynamicExecutable PROPERTIES INSTALL_RPATH "\$ORIGIN")

# Libraries to link with.
if(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
    target_link_libraries(
        shastaDynamicExecutable
        shastaDynamicLibrary
        atomic boost_system boost_program_options boost_chrono spoa cpu_features png z pthread)
else(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
    target_link_libraries(
        shastaDynamicExecutable
        shastaDynamicLibrary
        atomic boost_system boost_program_options boost_chrono spoa png z pthread)
endif(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)

if(BUILD_DEBUG) 
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif(BUILD_DEBUG)

# Install the dynamic executable into the bin directory.
install(TARGETS shastaDynamicExecutable DESTINATION shasta-install/bin)

# When install is complete, create the AppImage.
if(BUILD_APPIMAGE)
install(CODE "execute_process(COMMAND ${CMAKE_SOURCE_DIR}/AppImage/CreateAppImage.py shasta-install)")
endif(BUILD_APPIMAGE)

=== dynamicLibrary/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(shastaDynamicLibrary)

# C++ dialect.
add_definitions(-std=c++14)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
    add_definitions(-fsanitize=address)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# Definitions that control what components get built.
add_definitions(-DSHASTA_HTTP_SERVER)
add_definitions(-DSHASTA_PYTHON_API)

# Sources files.
file(GLOB SOURCES ../src/*.cpp)

# Include directory.
include_directories(../src)

# Define our library.
add_library(shastaDynamicLibrary SHARED ${SOURCES})

# Make sure the library is named shasta.so.
set_target_properties(shastaDynamicLibrary PROPERTIES OUTPUT_NAME "shasta")
set_target_properties(shastaDynamicLibrary PROPERTIES PREFIX "")
set_target_properties(shastaDynamicLibrary PROPERTIES DEFINE_SYMBOL "")

# Python 3 and pybind11.
# I was not able to get find_package to work with pybind11 as installed by pip3.
# The code below creates include paths for both Python 3 and pybind11.

# Python 3.8 requires the `--embed` flag to be passed in.
# find_python cmake module was introduced in v3.12, which isn't available for installation
# via `apt` on Ubuntu 18.04 LTS. So I am not using it. 
execute_process(COMMAND /usr/bin/python3-config --embed --libs OUTPUT_VARIABLE
SHASTA_PYTHON_LIBRARIES RESULT_VARIABLE COMMAND_RESULT)
if(${COMMAND_RESULT} EQUAL 0)
    # Python3 version is >= 3.8.0. So the --embed flag worked. Otherwise the command
    # would have failed with a non-zero exit code.
else()
    execute_process(COMMAND /usr/bin/python3-config --libs OUTPUT_VARIABLE SHASTA_PYTHON_LIBRARIES)
endif()
execute_process(COMMAND python3 -m pybind11 --includes OUTPUT_VARIABLE SHASTA_PYTHON_INCLUDES)
add_definitions(${SHASTA_PYTHON_INCLUDES})
string(STRIP ${SHASTA_PYTHON_LIBRARIES} SHASTA_PYTHON_LIBRARIES)
SET(CMAKE_LINKER_FLAGS  "${CMAKE_LINKER_FLAGS} ${SHASTA_PYTHON_LIBRARIES}")

# Libraries to link with.
target_link_libraries(
    shastaDynamicLibrary 
     atomic png boost_program_options pthread z spoa ${SHASTA_PYTHON_LIBRARIES})

# Install the shared library into the bin directory.
install(TARGETS shastaDynamicLibrary DESTINATION shasta-install/bin)

=== staticExecutable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(shastaStaticExecutable)

# C++ dialect.
add_definitions(-std=c++14)

# Compilation warnings.
if(NOT MACOS)
    add_definitions(-Wall -Wconversion -Wno-unused-result)
endif(NOT MACOS)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
    add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# Definitions that control what components get built.
add_definitions(-DSHASTA_HTTP_SERVER)

# Source files
file(GLOB SOURCES ../srcMain/*.cpp)

# Include directory.
include_directories(../src)

# Include directories required on macOS.
if(MACOS)
    set(Boost_USE_STATIC_LIBS ON)
    find_package(Boost REQUIRED COMPONENTS program_options chrono)
    include_directories(/usr/local/include/)
    include_directories(${Boost_INCLUDE_DIRS})
endif(MACOS)

# Define our executable.
add_executable(shastaStaticExecutable ${SOURCES})
set_target_properties(shastaStaticExecutable PROPERTIES OUTPUT_NAME "shasta")

# Request a static executable.
# For macOS, this is not supported, and we only link some of the libraries statically.
if(NOT MACOS)
    set_target_properties(shastaStaticExecutable PROPERTIES LINK_FLAGS "-static" )
endif(NOT MACOS)

# Libraries to link with.
if(MACOS)
    find_library(PNG_LIBRARY libpng.a REQUIRED)
    #find_library(Z_LIBRARY libz.a REQUIRED)
    target_link_libraries(
    shastaStaticExecutable 
    shastaStaticLibrary
    ${Boost_LIBRARIES} /usr/local/lib/libspoa.a ${PNG_LIBRARY} z pthread)
else(MACOS)
    # For arcane reasons, statically linking with the pthread
    # library on Linux requires "--whole-archive".
    if(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
        target_link_libraries(
            shastaStaticExecutable
            shastaStaticLibrary
            atomic boost_system boost_program_options boost_chrono spoa cpu_features png z
            -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
    else(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
        target_link_libraries(
            shastaStaticExecutable
            shastaStaticLibrary
            atomic boost_system boost_program_options boost_chrono spoa png z
            -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
    endif(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH) 
    
endif(MACOS)
  
# Also request the glibc library to be linked statically. 
# This is not supported on macOS.   
if(NOT MACOS)
    SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -static-libstdc++ -static-libgcc")
endif(NOT MACOS)

# The static executable goes to the bin directory.
install(TARGETS shastaStaticExecutable DESTINATION shasta-install/bin)

=== staticLibrary/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(shastaStaticLibrary)

# C++ dialect.
add_definitions(-std=c++14)

# Compilation warnings.
if(NOT MACOS)
    add_definitions(-Wall -Wconversion -Wno-unused-result)
endif(NOT MACOS)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# Definitions that control what components get built.
add_definitions(-DSHASTA_HTTP_SERVER)

# Sources files.
file(GLOB SOURCES ../src/*.cpp)

# Include directory.
include_directories(../src)

# Include directories required on macOS.
if(MACOS)
    set(Boost_USE_STATIC_LIBS ON)
    find_package(Boost REQUIRED COMPONENTS program_options chrono)
    include_directories(/usr/local/include/)
    include_directories(${Boost_INCLUDE_DIRS})
endif(MACOS)

# Define our library.
add_library(shastaStaticLibrary STATIC ${SOURCES})

# Make sure the library is named shasta.a.
set_target_properties(shastaStaticLibrary PROPERTIES OUTPUT_NAME "shasta")
set_target_properties(shastaStaticLibrary PROPERTIES PREFIX "")
set_target_properties(shastaStaticLibrary PROPERTIES DEFINE_SYMBOL "")

# Install the static library into the bin directory.
install(TARGETS shastaStaticLibrary DESTINATION shasta-install/bin)

=== debian/changelog ===
shasta (0.6.0-5ubuntu2) hirsute; urgency=medium

  * No-change rebuild for spoa soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 09 Jan 2021 16:22:32 +0100

shasta (0.6.0-5ubuntu1) hirsute; urgency=medium

  * Add cpu-features build-dep.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 05 Jan 2021 10:48:30 +0000

shasta (0.6.0-5) unstable; urgency=medium

  * Team upload.
  * Do not explicitly Depend libboost-chrono1.71.0 and use ${shlibs:Depends}
    instead
    Closes: #977308

 -- Andreas Tille <tille@debian.org>  Sat, 19 Dec 2020 20:46:29 +0100

shasta (0.6.0-4) unstable; urgency=medium

  * Team Upload.
  * Modify install paths (Closes: #972921)
  * Fix installmissing

 -- Nilesh Patra <npatra974@gmail.com>  Wed, 09 Dec 2020 12:05:18 +0000

shasta (0.6.0-3) unstable; urgency=medium

  * Team upload.
  * python3-shasta: any-amd64 arm64

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 17:49:17 +0100

shasta (0.6.0-2) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Enable binary-all build
    Closes: #972921
  * Architecture: any-amd64 arm64
    Closes: #972922
  * Do not override dh_missing, try to install the files from debian/tmp
    or remove them before dh_missing is called
  * Make sure shared library will fit default Python3 version
  * dh_missing --fail-missing
  * Standards-Version: 5.4.1

  [ Shayan Doust ]
  * build depends python3-dev instead of python3-all-dev
    Closes: #973427

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 14:37:49 +0100

shasta (0.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Move source package lintian overrides to debian/source.

 -- Andreas Tille <tille@debian.org>  Fri, 23 Oct 2020 14:49:17 +0200

shasta (0.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #968716)

 -- Shayan Doust <hello@shayandoust.me>  Thu, 20 Aug 2020 16:47:28 +0000

=== debian/control ===
Source: shasta
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               dh-exec,
               cmake,
               patchelf,
               chrpath,
               libboost-all-dev,
               libpng-dev,
               ncbi-blast+,
               python3-sphinx,
               python3-dev,
               libseqan2-dev,
               libcpu-features-dev,
               libspoa-dev,
               python3-pybind11
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/shasta
Vcs-Git: https://salsa.debian.org/med-team/shasta.git
Homepage: https://github.com/chanzuckerberg/shasta
Rules-Requires-Root: no

Package: shasta
Architecture: any-amd64 arm64
Depends: ${misc:Depends},
         ${shlibs:Depends},
         python3-shasta (= ${binary:Version}),
Description: nanopore whole genome assembly (binaries and scripts)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the executable binaries (tools) and
 accommodating scripts.

Package: python3-shasta
Architecture: any-amd64 arm64
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         libboost-program-options1.71.0,
         libpng16-16,
         libpng-dev,
         ncbi-blast+,
         libseqan2-dev,
         libspoa-dev
Description: nanopore whole genome assembly (dynamic library)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the dynamic library that can be interfaced and
 imported within Python.

Package: python3-shasta-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends},
         ${misc:Depends}
Recommends: shasta,
            python3-shasta
Description: nanopore whole genome assembly (documentation)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the documentation for the shasta and python3-shasta
 packages.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
MULTIARCH_SONAME = shasta.cpython-$(shell py3versions -vd | sed 's/\.//')-$(DEB_HOST_MULTIARCH).so

%:
	dh $@ --with python3,sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_ID=${DEB_VERSION_UPSTREAM}

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
	# Move shared library into sphinx documentation folder for doc generation
	find . -name "shasta.so" -exec cp {} docs/PythonApi/ \;
	PYTHONPATH=docs/PythonApi/ python3 -m sphinx -N -bhtml docs/PythonApi/ build/html # HTML generator

override_dh_python3:
	dh_python3
	patchelf \
		--set-soname $(MULTIARCH_SONAME) \
		$(CURDIR)/debian/python3-shasta/usr/lib/python3/dist-packages/$(MULTIARCH_SONAME)

override_dh_install-arch:
	dh_install -a
	# Rename shastaDynamic to shasta for ease
	mv debian/shasta/usr/bin/shastaDynamic debian/shasta/usr/bin/shasta
	# The library is in a more unusual place (nested within /usr/lib), so modify
	# the ELF
	chrpath -r /usr/lib/python3/dist-packages \
		debian/shasta/usr/bin/shasta
	patchelf \
		--replace-needed shasta.so $(MULTIARCH_SONAME) \
		debian/shasta/usr/bin/shasta

override_dh_missing:
	# No need to install docker files
	find debian/tmp -type d -name docker | xargs rm -rf
	# static library should not be installed
	find debian/tmp -name shasta.a -delete
	# dynamic library was installed manually before - so remove it from debian/tmp
	find debian/tmp -name shasta.so -delete
	# 11MB of generated docs should go into a separate package if this is considered sensible
	# FIXME: for the moment do not install these
	find debian/tmp -name docs | xargs rm -rf
	# Remove rest of files which have already been installed
	rm -rf debian/tmp/${CURDIR}
	dh_missing --list-missing

## shasta 0.7.0

=== dynamicExecutable/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,10 @@
 if(BUILD_DEBUG)
     add_definitions(-ggdb3)
     add_definitions(-O0)
-    add_definitions(-fsanitize=address)
+    # Address sanitizer does not work well with the Python API,
+    # so it is commented out here. But it could be useful
+    # to debug the dynamic executable. 
+    # add_definitions(-fsanitize=address)
 else(BUILD_DEBUG)
     add_definitions(-g0)
     add_definitions(-O3)
@@ -39,7 +42,10 @@
 add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)
 
 # Definitions that control what components get built.
-add_definitions(-DSHASTA_HTTP_SERVER)
+if(BUILD_WITH_HTTP_SERVER)
+    add_definitions(-DSHASTA_HTTP_SERVER)
+endif(BUILD_WITH_HTTP_SERVER)
+
 add_definitions(-DSHASTA_PYTHON_API)
 
 # Source files
@@ -57,17 +63,17 @@
 set_target_properties(shastaDynamicExecutable PROPERTIES INSTALL_RPATH "\$ORIGIN")
 
 # Libraries to link with.
-if(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
+if(X86_64)
     target_link_libraries(
         shastaDynamicExecutable
         shastaDynamicLibrary
         atomic boost_system boost_program_options boost_chrono spoa cpu_features png z pthread)
-else(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
+else(X86_64)
     target_link_libraries(
         shastaDynamicExecutable
         shastaDynamicLibrary
         atomic boost_system boost_program_options boost_chrono spoa png z pthread)
-endif(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
+endif(X86_64)
 
 if(BUILD_DEBUG) 
     set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")

=== dynamicLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,10 @@
 if(BUILD_DEBUG)
     add_definitions(-ggdb3)
     add_definitions(-O0)
-    add_definitions(-fsanitize=address)
+    # Address sanitizer does not work well with the Python API,
+    # so it is commented out here. But it could be useful
+    # to debug the dynamic executable. 
+    # add_definitions(-fsanitize=address)
 else(BUILD_DEBUG)
     add_definitions(-g0)
     add_definitions(-O3)
@@ -40,7 +43,10 @@
 add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)
 
 # Definitions that control what components get built.
-add_definitions(-DSHASTA_HTTP_SERVER)
+if(BUILD_WITH_HTTP_SERVER)
+    add_definitions(-DSHASTA_HTTP_SERVER)
+endif(BUILD_WITH_HTTP_SERVER)
+
 add_definitions(-DSHASTA_PYTHON_API)
 
 # Sources files.

=== staticExecutable/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,9 @@
 add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)
 
 # Definitions that control what components get built.
-add_definitions(-DSHASTA_HTTP_SERVER)
+if(BUILD_WITH_HTTP_SERVER)
+    add_definitions(-DSHASTA_HTTP_SERVER)
+endif(BUILD_WITH_HTTP_SERVER)
 
 # Source files
 file(GLOB SOURCES ../srcMain/*.cpp)
@@ -77,19 +79,19 @@
 else(MACOS)
     # For arcane reasons, statically linking with the pthread
     # library on Linux requires "--whole-archive".
-    if(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
+    if(X86_64)
         target_link_libraries(
             shastaStaticExecutable
             shastaStaticLibrary
             atomic boost_system boost_program_options boost_chrono spoa cpu_features png z
             -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
-    else(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH)
+    else(X86_64)
         target_link_libraries(
             shastaStaticExecutable
             shastaStaticLibrary
             atomic boost_system boost_program_options boost_chrono spoa png z
             -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
-    endif(X86_64 AND BUILD_USE_SPOA_WITH_CPU_DISPATCH) 
+    endif(X86_64) 
     
 endif(MACOS)

=== staticLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,9 @@
 add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)
 
 # Definitions that control what components get built.
-add_definitions(-DSHASTA_HTTP_SERVER)
+if(BUILD_WITH_HTTP_SERVER)
+    add_definitions(-DSHASTA_HTTP_SERVER)
+endif(BUILD_WITH_HTTP_SERVER)
 
 # Sources files.
 file(GLOB SOURCES ../src/*.cpp)

=== debian/changelog ===
shasta (0.7.0-3) unstable; urgency=medium

  * Team upload.
  * python3-shasta: Remove explicit depends on many libraries,
    ${shlibs:Depends} covers the needful.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 13 Jan 2021 10:43:17 +0100

shasta (0.7.0-2) unstable; urgency=medium

  * Team upload.
  * make use of ${sphinxdoc:Built-Using}
  * debian/tests/control: specifically depend on the binary packages
  * debian/control: document why package is amd64/arm64 only

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 12 Jan 2021 13:08:34 +0100

shasta (0.7.0-1) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * debian/patches/libspoa7.0.0: adapt to spoa 4.0.6 (Closes: #979704)
  * Fix some typos.

  [ Juhani Numminen ]
  * Fix binary-indep FTBFS: add suffix -arch in execute_after_dh_python3-arch.

  [ Andreas Tille ]
  * New upstream version
  * Build-Depends: libcpu-features-dev

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 11 Jan 2021 16:28:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: shasta
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
@@ -16,9 +15,10 @@
                python3-sphinx,
                python3-dev,
                libseqan2-dev,
-               libcpu-features-dev,
                libspoa-dev,
-               python3-pybind11
+               python3-pybind11,
+               libcpu-features-dev [any-amd64],
+               libcereal-dev
 Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/shasta
 Vcs-Git: https://salsa.debian.org/med-team/shasta.git
@@ -27,6 +27,10 @@
 
 Package: shasta
 Architecture: any-amd64 arm64
+# even if one comments out the sections that forbid compilation on other archs
+# one gets this error message:
+# undefined reference to `__sync_bool_compare_and_swap_16'
+# see src/dset64.hpp for more details
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          python3-shasta (= ${binary:Version}),
@@ -57,12 +61,7 @@
 Depends: ${python3:Depends},
          ${shlibs:Depends},
          ${misc:Depends},
-         libboost-program-options1.71.0,
-         libpng16-16,
-         libpng-dev,
-         ncbi-blast+,
-         libseqan2-dev,
-         libspoa-dev
+         ncbi-blast+
 Description: nanopore whole genome assembly (dynamic library)
  De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
  read assembler is to rapidly produce accurate assembled sequence using
@@ -86,7 +85,9 @@
 
 Package: python3-shasta-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
+Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${sphinxdoc:Depends},
          ${misc:Depends}
 Recommends: shasta,

=== debian/rules ===
--- 
+++ 
@@ -25,12 +25,6 @@
 	find . -name "shasta.so" -exec cp {} docs/PythonApi/ \;
 	PYTHONPATH=docs/PythonApi/ python3 -m sphinx -N -bhtml docs/PythonApi/ build/html # HTML generator
 
-override_dh_python3:
-	dh_python3
-	patchelf \
-		--set-soname $(MULTIARCH_SONAME) \
-		$(CURDIR)/debian/python3-shasta/usr/lib/python3/dist-packages/$(MULTIARCH_SONAME)
-
 override_dh_install-arch:
 	dh_install -a
 	# Rename shastaDynamic to shasta for ease
@@ -42,6 +36,11 @@
 	patchelf \
 		--replace-needed shasta.so $(MULTIARCH_SONAME) \
 		debian/shasta/usr/bin/shasta
+
+execute_after_dh_python3-arch:
+	patchelf \
+		--set-soname $(MULTIARCH_SONAME) \
+		$(CURDIR)/debian/python3-shasta/usr/lib/python3/dist-packages/$(MULTIARCH_SONAME)
 
 override_dh_missing:
 	# No need to install docker files

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/chanzuckerberg/shasta/releases .*/archive/v?@ANY_VERSION@\.tar\.gz

## shasta 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,26 +30,15 @@
     option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
     option(BUILD_DYNAMIC_LIBRARY "Build the shared library." OFF)
     option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)
+    option(BUILD_WITH_HTTP_SERVER "Build with embedded HTTP server for debugging." ON)
     option(BUILD_APPIMAGE "Build the AppImage." OFF)
 else(MACOS)
-    # SPOA's cpu dispatching code does not compile on Ubuntu versions lesser than 18.04
-    execute_process(COMMAND cat /etc/os-release
-        COMMAND grep VERSION_ID
-        COMMAND cut -f 2 -d=
-        COMMAND tr -d \"
-        OUTPUT_VARIABLE UBUNTU_VERSION)
-    if(UBUNTU_VERSION VERSION_LESS "18.04")
-        option(BUILD_USE_SPOA_WITH_CPU_DISPATCH "Link to SPOA library which uses cpu dispatch" OFF)    
-    else(UBUNTU_VERSION VERSION_LESS "18.04")
-        option(BUILD_USE_SPOA_WITH_CPU_DISPATCH "Link to SPOA library which uses cpu dispatch" ON)
-    endif(UBUNTU_VERSION VERSION_LESS "18.04")
-    message(STATUS "BUILD_USE_SPOA_WITH_CPU_DISPATCH is " ${BUILD_USE_SPOA_WITH_CPU_DISPATCH})
-   
     # For Linux, build everything.
     option(BUILD_STATIC_LIBRARY "Build the static library." ON)
     option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
     option(BUILD_DYNAMIC_LIBRARY "Build the shared library." ON)
     option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." ON)
+    option(BUILD_WITH_HTTP_SERVER "Build with embedded HTTP server for debugging." ON)
     option(BUILD_APPIMAGE "Build the AppImage." OFF)
 endif(MACOS)
 
@@ -141,9 +130,6 @@
 # Install the docs directory.
 install(DIRECTORY docs DESTINATION shasta-install)
 
-# Install the docker directory.
-install(DIRECTORY docker DESTINATION shasta-install)
-
 # The targets built in each subdirectory are
 # installed by the cmake file of each subdirectory.

=== dynamicExecutable/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(shastaDynamicExecutable)
 
 # C++ dialect.
-add_definitions(-std=c++14)
+add_definitions(-std=c++17)
 
 # Compilation warnings.
 add_definitions(-Wall -Wconversion -Wno-unused-result)
@@ -67,12 +67,14 @@
     target_link_libraries(
         shastaDynamicExecutable
         shastaDynamicLibrary
-        atomic boost_system boost_program_options boost_chrono spoa cpu_features png z pthread)
+        atomic boost_system boost_program_options boost_chrono spoa cpu_features png z 
+        lapack blas gfortran quadmath pthread)
 else(X86_64)
     target_link_libraries(
         shastaDynamicExecutable
         shastaDynamicLibrary
-        atomic boost_system boost_program_options boost_chrono spoa png z pthread)
+        atomic boost_system boost_program_options boost_chrono spoa png z 
+        lapack blas gfortran pthread)
 endif(X86_64)
 
 if(BUILD_DEBUG)

=== dynamicLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 project(shastaDynamicLibrary)
 
 # C++ dialect.
-add_definitions(-std=c++14)
+add_definitions(-std=c++17)
 
 # Compilation warnings.
 add_definitions(-Wall -Wconversion -Wno-unused-result)
@@ -86,7 +86,7 @@
 # Libraries to link with.
 target_link_libraries(
     shastaDynamicLibrary 
-     atomic png boost_program_options pthread z spoa ${SHASTA_PYTHON_LIBRARIES})
+     atomic png boost_program_options pthread z spoa lapack blas ${SHASTA_PYTHON_LIBRARIES})
 
 # Install the shared library into the bin directory.
 install(TARGETS shastaDynamicLibrary DESTINATION shasta-install/bin)

=== staticExecutable/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(shastaStaticExecutable)
 
 # C++ dialect.
-add_definitions(-std=c++14)
+add_definitions(-std=c++17)
 
 # Compilation warnings.
 if(NOT MACOS)
@@ -75,7 +75,9 @@
     target_link_libraries(
     shastaStaticExecutable 
     shastaStaticLibrary
-    ${Boost_LIBRARIES} /usr/local/lib/libspoa.a ${PNG_LIBRARY} z pthread)
+    ${Boost_LIBRARIES} /usr/local/lib/libspoa.a ${PNG_LIBRARY} z
+    "-framework Accelerate"
+    pthread)
 else(MACOS)
     # For arcane reasons, statically linking with the pthread
     # library on Linux requires "--whole-archive".
@@ -84,12 +86,14 @@
             shastaStaticExecutable
             shastaStaticLibrary
             atomic boost_system boost_program_options boost_chrono spoa cpu_features png z
+            lapack blas gfortran quadmath
             -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
     else(X86_64)
         target_link_libraries(
             shastaStaticExecutable
             shastaStaticLibrary
             atomic boost_system boost_program_options boost_chrono spoa png z
+            lapack blas gfortran
             -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
     endif(X86_64)

=== staticLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(shastaStaticLibrary)
 
 # C++ dialect.
-add_definitions(-std=c++14)
+add_definitions(-std=c++17)
 
 # Compilation warnings.
 if(NOT MACOS)

=== debian/changelog ===
shasta (0.8.0-2ubuntu1) jammy; urgency=medium

  * d/tests/run-unit-test: Disable shasta binary test as it requires too much
    memory, even with the configuration for big_packages.

 -- Alexandre Ghiti <alexandre.ghiti@canonical.com>  Tue, 15 Feb 2022 14:29:09 +0100

shasta (0.8.0-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:31:16 +0000

shasta (0.8.0-2) unstable; urgency=medium

  * Team Upload.
  * Cherry-pick upstream patch to fix FTBFS (Closes: #1002142)

 -- Nilesh Patra <nilesh@debian.org>  Tue, 04 Jan 2022 01:10:16 +0530

shasta (0.8.0-1) unstable; urgency=medium

  * Team upload.

  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

  [ Nilesh Patra ]
  * d/control: Add libblas-dev,liblapack-dev,gfortran to B-D
  * d/t/run-unit-test: Specify a --config builtin for running test on sample
    data

 -- Andreas Tille <tille@debian.org>  Thu, 14 Oct 2021 08:17:30 +0200

=== debian/control ===
--- 
+++ 
@@ -18,8 +18,11 @@
                libspoa-dev,
                python3-pybind11,
                libcpu-features-dev [any-amd64],
-               libcereal-dev
-Standards-Version: 4.5.1
+               libcereal-dev,
+               libblas-dev,
+               liblapack-dev,
+               gfortran
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/shasta
 Vcs-Git: https://salsa.debian.org/med-team/shasta.git
 Homepage: https://github.com/chanzuckerberg/shasta

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/chanzuckerberg/shasta/releases .*/v?@ANY_VERSION@\.tar\.gz
